-----------------------------------------------------------------------------

local AloftHealthData = Aloft:NewModule("HealthData", "AceEvent-2.0")

-----------------------------------------------------------------------------

Aloft.TagData.health =
{
	data = "health",
	events = "Aloft:OnHealthDataChanged",
	overrideEvents = "Aloft:OnHealthBarValueChanged",
	tableData = "health"
}

Aloft.TagData.maxhealth =
{
	data = "maxHealth",
	events = "Aloft:OnHealthDataChanged",
	overrideEvents = "Aloft:OnHealthBarValueChanged",
	tableData = "maxHealth"
}

Aloft.TagData.healthdeficit =
{
	data = { "health", "maxHealth" },
	events = "Aloft:OnHealthDataChanged",
	overrideEvents = "Aloft:OnHealthBarValueChanged",
	method = function(aloftData, value)
				if value and aloftData.health and aloftData.maxHealth then
					return aloftData.maxHealth - aloftData.health
				else    
					return nil 
				end     
			 end
}

Aloft.TagData.hideknownhealth =
{
	data = "health",
	events = "Aloft:OnHealthDataChanged",
	overrideEvents = "Aloft:OnHealthBarValueChanged",
	compileString = function(dataTable, prior) return string.format("(not data.health%s%s)", prior and " and " or "", prior or "") end
}
 
-----------------------------------------------------------------------------

function AloftHealthData:ProvidesData()
	return "health", "maxHealth"
end

-----------------------------------------------------------------------------

function AloftHealthData:EnableDataSource()
	self:RegisterEvent("Aloft:OnHealthBarValueChanged", "OnHealthBarValueChanged")
end

-----------------------------------------------------------------------------

function AloftHealthData:UpdateData(aloftData)
    if aloftData.healthBarMaxValue ~= 100 then
        aloftData.health = aloftData.healthBarValue
        aloftData.maxHealth = aloftData.healthBarMaxValue
    elseif MobHealth3 then
        local health, maxHealth, valid = MobHealth3:GetHealth(aloftData.healthBarValue, aloftData.healthBarMaxValue, aloftData.name, aloftData.level or -1)
        if valid then
            aloftData.health = health
            aloftData.maxHealth = maxHealth
        else
            aloftData.health = nil
            aloftData.maxHealth = nil
        end
    else
        aloftData.health = nil
        aloftData.maxHealth = nil
    end
end

-----------------------------------------------------------------------------

function AloftHealthData:OnHealthBarValueChanged(aloftData)
	self:UpdateData(aloftData)
	self:TriggerEvent("Aloft:OnHealthDataChanged", aloftData)
end

-----------------------------------------------------------------------------
